stages:
  - build
  - quality-control
  - publish

build:
  stage: build
  image: debian:testing
  variables:
    TOOL_ARGS: apt-get -o Debug::pkgProblemResolver=yes --no-install-recommends --yes
  before_script:
    - apt-get update
    - apt-get install -y gnupg devscripts
  script:
    - mk-build-deps --install --tool="$TOOL_ARGS" debian/control
    - rm -f *build-deps*.deb
    - ./build-deb.sh
  artifacts:
    paths:
      - build
  tags:
    - merge
    - docker

mock:
  stage: build
  image: golang:1.14
  script:
    - MOCK=1 make
    - mkdir mock
    - mv build/rex mock/rex
    - mv build/driver mock/driver
  artifacts:
    paths:
      - mock
  tags:
    - merge
    - docker

quality-control:
  stage: quality-control
  image: debian:testing
  before_script:
    - apt update
    - apt install -y golang golint make ca-certificates curl git
  script:
    - make tools
    - make qc
  tags:
    - merge
    - docker

publish:
  stage: publish
  image: debian:testing
  before_script:
    - apt update
    - apt install curl dpkg-sig -y
    - 'curl -L https://gitlab.com/mergetb/devops/pkg/raw/master/add-deb.sh > add-deb.sh'
    - chmod +x add-deb.sh
    - echo $MERGETB_GPG_KEY | base64 -di | gpg --import
  script:
    - dpkg-sig -k $MERGETB_GPG_KEY_ID --sign builder build/*.deb
    - find . -name "*.deb" | RELEASE=bullseye xargs -n 1 ./add-deb.sh
    - find . -name "*.deb" | RELEASE=buster xargs -n 1 ./add-deb.sh
  dependencies:
    - build
  only:
    - tags
  tags:
    - merge
    - docker
